<?php
function export_apprentice($deck, $title) {
	global $sbreplace;

	// transform sideboard
	$sb = array_search($sbreplace, $deck);
	if ($sb) {
		for (;++$sb < count($deck);) {
			$deck[$sb] = "SB:  " . $deck[$sb];
		}
	}

	// add title
	array_unshift($deck, "// Name: $title");

	// change comment symbols
	foreach ($deck as &$line) {
		$line = preg_replace("/--/", "// ", $line);
	}

	$deck = implode("\n", $deck);

	return $deck;
};

function export_mtgo($deck, $title) {
	global $sbreplace;

	// transform sideboard
	$sb = array_search($sbreplace, $deck);
	if ($sb) {
		$deck[$sb] = "Sideboard";
	}

	// remove comments and empty lines
	for ($i=count($deck)-1; $i >= 0; $i--) {
		if (preg_match("/^($|--)/", $deck[$i])) {
			array_splice($deck, $i, 1);
		}
	}

	$deck = implode("\n", $deck);

	return $deck;
};

$exportdeck = array();
$exportdeck['apprentice'] = export_apprentice;
$exportdeck['mtgo'] = export_mtgo;

$extension = array();
$extension['apprentice'] = "dec";
$extension['mtgo'] = "txt";

require_once("SSI.php");
$query = $_SERVER['QUERY_STRING'];
parse_str($query);
if (!isset($post) || !isset($deckid)) {
	exit;
}
if (!isset($format) || !isset($exportdeck[$format])) {
	$format = 'apprentice';
}

$sbreplace = "--sideboard";

//ssi_fetchPosts($post_ids, $override_permissions = false, $output_method = 'echo', $parsebbc = true)

$post = ssi_fetchPosts($post, true, 'array', false);


$body = $post[0]["body"]; //string

// find decks in post
preg_match_all("/\[deck.*?\/deck]/", $body, $decks); //array

$deck = html_entity_decode($decks[0][$deckid]);
$deck = explode('<br />', $deck);
for ($i=0; $i<count($deck);$i++) {
	$deck[$i] = preg_replace("/(.)({.*}|--.*)?\s*$/", "$1", html_entity_decode(trim($deck[$i]), ENT_QUOTES));
	$deck[$i] = preg_replace("/.*sideboard.*/i", $sbreplace, $deck[$i]);
}

//get deck title from first line
$title = "";
if (preg_match("/=/", $deck[0])) {
	$title = preg_replace("/^.*=(.*)\]$/", "$1", $deck[0]);
}

//trim the ends of the decklist, which contains [deck][/deck] tags
array_pop($deck);
array_shift($deck);

$deck = $exportdeck[$format]($deck, $title);

header("Content-type: text/plain");
header("Content-Disposition: attachment; filename=\"$title.{$extension[$format]}\"" );

print($deck);

?>